function [final_delta_gamma1,TD1,TG1,alpha1,partition,prob_matrix,trans_matrix,correlation,mir]=genomecodenomod(fseq)

number.sequences=length(fseq);

%partitions with 16 columns and order 4
max_N=20;
max_T=10;

correlation=zeros(max_N,max_T);
length_symb_seq=4;
num_symbols=4;
p=fseq.Header;
n=fseq.Sequence;

seq=zeros(size(n));
for a=1:1:length (n)
    if (n(a)=='A')
        seq(a)=0;
    end
    if (n(a)=='T')
        seq(a)=1;
    end
    if (n(a)=='G')
        seq(a)=2;
    end
    if (n(a)=='C')
        seq(a)=3;
    end   
end
 
for N=4:max_N
orderT=log2(N);
half_orderT=(1.*orderT)/2;
    
for tau=1:max_T
delta=zeros(length(n)-length_symb_seq,1);
gamma=zeros(length(n)-length_symb_seq,1);
partition=zeros(length(n)-length_symb_seq,2);
trans_matrix=zeros(N*N,N*N);
prob_matrix=zeros(N*N,1);
 
 for i_dg=length_symb_seq+1:1:length(n)-length_symb_seq-tau+1;
 d=zeros(length_symb_seq,1);
    
    for k=1:length_symb_seq;
            delta(i_dg)=delta(i_dg)+seq(i_dg-k)*(num_symbols^(length_symb_seq-k))/(4^length_symb_seq-1);
           
            if (k <= half_orderT && 2^orderT==N) 
                partition(i_dg,1)=partition(i_dg,1)+seq(i_dg-k)*(num_symbols^(half_orderT-k));
            else
                partition(i_dg,1)=floor(delta(i_dg)*N);
            end           
    end
    if (partition(i_dg,1)+1 <= N) 
        partition(i_dg,1)=partition(i_dg,1)+1;
    end
    
    c=zeros(length_symb_seq,1);
   
    for k=1:length_symb_seq;    
        gamma(i_dg)=gamma(i_dg)+seq(i_dg+k-1)*(num_symbols^(length_symb_seq-k))/(4^length_symb_seq-1);    

             if (k <= half_orderT  && 2^orderT==N) 
                partition(i_dg,2)=partition(i_dg,2)+seq(i_dg+k-1)*(num_symbols^(half_orderT-k));
             else
                
                 partition(i_dg,2)=floor(gamma(i_dg)*N);               
                 
             end

    end
     if (partition(i_dg,2)+1 <= N) 
        partition(i_dg,2)=partition(i_dg,2)+1;
     end
    
    index=partition(i_dg,1)+(partition(i_dg,2)-1)*N;
% matrix bellow is integer, not a probabilistic measure
    prob_matrix0(index,1)=prob_matrix(index)+1; % prob matrix0 counts for tau=0, without moving the symbolic sequence.
    %./(length(n)-2*length_symb_seq-1);    
    
end

total.delta(1:length(delta))=delta;
total.gamma(1:length(gamma))=gamma;
TD1=total.delta;
TG1=total.gamma;

 delta_transpose=reshape(total.delta.',[],1);
 gamma_transpose=reshape(total.gamma.',[],1);
  
alpha1=horzcat(delta_transpose(:,1),gamma_transpose(:,1));
final_delta_gamma1=alpha1;

l=partition(:,1)<1;
partition(l,:)=[];

cells=partition(:,1)+(partition(:,2)-1)*N;
trans_matrix=full(sparse(cells(1:end-tau,1),cells(tau+1:end,1),1));
prob_matrix=sum(trans_matrix,2);
trans_matrix=trans_matrix./repmat(prob_matrix,1,N*N);
prob_matrix=prob_matrix/sum(prob_matrix);
 for decay_time=1:100  
     Z=(trans_matrix)^decay_time;
     if Z~0;
         break
         decay_time
     end
 end 
cortemp=0;
for i=1:N
    for j=1:N
        cortemp=cortemp+prob_matrix(i)*trans_matrix(i,j)-prob_matrix(i)*prob_matrix(j);
    end
end      
        correlation(N,tau)=cortemp;

        
pitemp=tabulate(partition(:,1));
p_i=pitemp(:,3)/100;

pjtemp=tabulate(partition(:,1));
p_j=pjtemp(:,3)/100;


end
%tau

end
%N

%end
%lenght of sequence
% end